#ifndef __BMPLOADER_H
#define __BMPLOADER_H

#define MIN_TEX_DIM 16   // typical min width/height of texture
#define MAX_TEX_DIM 2048 // typical max width/height of texture

class impBmp;

class BmpLoader
{
public:
  BmpLoader();
  ~BmpLoader();

  bool LoadFromFile(const char *strFileName);

  int* GetRAWptr();
  int  GetXRes();
  int  GetYRes();

  void Resize(int w, int h);
  void ResizeToTexture();     // resize to power of 2

private:  
  int  RoundPower2(int w);
  void Odd2Even();
  void BGR2RGB(int *data, int w, int h); // converts BGR image data to RGB

  impBmp* m_pBMP;
};

#endif