#ifndef __CollisionDedector_H_
#define __CollisionDedector_H_
#include "point.h"
#include "particlesim.h"

#define GROUND_W     64
#define GROUND_CELLW 2.0f

struct plane_t {
  GLLIB_vtx n;
  float k;
};

class Ground {
public:
  Ground();
  float GetDistance(GLLIB_vtx *n, GLLIB_vtx *p0, GLLIB_vtx *p);
  GLLIB_vtx GetVtx(int i, int j);
  
 private:
  float hfield[GROUND_W+1] [GROUND_W+1];
  
  plane_t planes[GROUND_W][GROUND_W][2];
  
  GLLIB_vtx o;
};

class CollisionDedector
{
 private:
  Point *pts;
  GLLIB_vtx *pos;
  int numOfPoints;
  
  Ground ground;
  
  ParticleSim *particle;
  
 public:
  void SetParticles(ParticleSim *particle);
  void init(int nofp, GLLIB_vtx *ps, Point *pt);
  void handleCollisions();
  void handleFriction();
  Ground *getGround();
};

#endif
