#include "stdafx.h"
#include <math.h>
#include "delayvariable.h"

void DelayVariable::Init(float initvalue, float min, float max, float slope_on, float slope_off)
{
  m_initvalue = initvalue;
  m_min = min;
  m_max = max;
  m_slope_on = slope_on;
  m_slope_off = slope_off;

  m_value = initvalue;
}

float DelayVariable::Step(float deltat, bool inc, bool dec)
{
  if(inc == dec)
  {
    if(fabs(m_value - m_initvalue) <= deltat*m_slope_off)
    {
      m_value = m_initvalue;
      return m_value;
    }

    if(m_value > m_initvalue)
    {
      m_value -= deltat*m_slope_off;
    }
    else
    {
      m_value += deltat*m_slope_off;
    }
  }
  else
  if(inc)
  {
    m_value += deltat*m_slope_on;

    if(m_value > m_max)
      m_value = m_max;
  }
  else // dec
  {
    m_value -= deltat*m_slope_on;

    if(m_value < m_min)
      m_value = m_min;
  }

  return m_value;
}

float DelayVariable::GetValue()
{
  return m_value;
}

float DelayVariable::GetInitlen()
{
  return m_initvalue;
}