#include "stdafx.h"
#include "engine.h"

#define MAX_TORQUE 50
#define MAX_POWER 80

#define LIMIT 0.5f
#define DIFF 0.8f
#define FAC 2.0f
#define LOW 1.0f
#define MAX 7.0f

void Engine::setThrottle(float t) {
  int i;
  float mean_rpm = 0.0f;
  float min_rpm = MAX * 2.0f;
  float dist[4];
  
  for(i=0; i<4; i++) {
    dist[i] = whl[i].GetRotSpeed();
    mean_rpm += dist[i];
    if(min_rpm > (float)fabs(dist[i])) min_rpm = (float)fabs(dist[i]);
  }
  mean_rpm /= 4.0f;
  min_rpm += 0.02f;

  if(!( (mean_rpm < -LIMIT && t > LIMIT) || 
  (mean_rpm > LIMIT && t < -LIMIT)) ) {
      
    mean_rpm = (float)fabs(mean_rpm) + 1.0f;
    
    if(min_rpm < LOW) t *= (0.5f + min_rpm / (2 * LOW));  
    else if(min_rpm > MAX) t = 0.0f; 
    
    float torque = t * MAX_POWER/mean_rpm;

    whl[0].SetTorque(torque);
    whl[3].SetTorque(torque);
    whl[1].SetTorque(torque);
    whl[2].SetTorque(torque);

  } else {
    for(i=0; i<4; i++) {
      whl[i].SetBreak(1.0);
    }
  }
}

void Engine::init(PoweredWheel *w) {
  whl = w;
}
