#ifndef __MAINENGINE_H
#define __MAINENGINE_H

#include "gllib.h"
#define ENGINE_MAX_KEYS   512

#define ENGINE_KEY_LEFT    (0x100 + 100)
#define ENGINE_KEY_UP      (0x100 + 101)
#define ENGINE_KEY_RIGHT  (0x100 + 102)
#define ENGINE_KEY_DOWN    (0x100 + 103)
#define ENGINE_KEY_END    (0x100 + 107)
#define ENGINE_KEY_F1      (0x100 + 1)
#define ENGINE_KEY_F2      (0x100 + 2)
#define ENGINE_KEY_F3      (0x100 + 3)
#define ENGINE_KEY_F4      (0x100 + 4)
#define ENGINE_KEY_F5      (0x100 + 5)
#define ENGINE_KEY_F6      (0x100 + 6)
#define ENGINE_KEY_F7      (0x100 + 7)
#define ENGINE_KEY_F8      (0x100 + 8)

#define ENGINE_KEY_ESC    27
#define ENGINE_KEY_SPACE  32

class MainEngine
{
public:
  MainEngine() {
    m_gllib = NULL;
  }

  ~MainEngine() {
  }

  // engine should do precalcs here and load stuff (also 3D)
  virtual bool InitAll() {
    assert(m_gllib != NULL);
    return true;
  }

  // called when all the stuff should be freed
  virtual bool DeinitAll() {
    return true;
  }

  // called for each render step. time is the
  // absolute time from the start of the app in seconds
  virtual bool RenderStep(float time) {
    return true;
  }

  bool Set3D(GLLib *gllib) {
    m_gllib = gllib;
    return true;
  }

  virtual void SetKeyState(int key, bool state) = 0;

protected:
  GLLib *m_gllib;
};

#endif
