#ifndef __PARTICLESIM_H
#define __PARTICLESIM_H

#include "gllib.h"

#define MAX_PARTICLE_LIFETIME 5.0f
#define PARTICLE_DRAG         0.99f
#define PARTICLE_G            -9.81f
#define PARTICLE_DIR_VARIANCE 0.4f
#define PARTICLE_EMITRATE     0.3f
#define PARTICLE_FRICTION     0.4f

class Ground;

struct particle_t {
  GLLIB_vtx   p, v;
  GLLIB_COLOR color;
  float life_start;
  bool  alive;

  GLLIB_vtx   rndvect;
};

class ParticleSim 
{
public:
  ParticleSim(int max_particles, Ground *ground);
  ~ParticleSim();

  void Simulate(float time, float deltat);
  particle_t *GetParticles(int *totaln, int *start, int *n);
  void NewParticle(GLLIB_vtx &pos, GLLIB_vtx &v0);
  void SetTime(float time);

private:
  float m_time;
  float m_deltatime;
  int m_n;
  particle_t *m_p;

  Ground *m_ground;

  int m_idx_alivestart;
  int m_nalive;
};

#endif