#include "stdafx.h"

#include "point.h"
#include <math.h>

void Point::init(int pt, GLLIB_vtx *ps, float x, float y, float z, float m) 
{
  a.x = .0f; a.y = G; a.z = .0f;
  aold.x = .0f; aold.y = G; aold.z = .0f;
  velocity.x = .0f; velocity.y = .0f; velocity.z = .0f;
  force.x = 0.0f; force.y = 0.0f; force.z = 0.0f;

  pos = ps;
  ptIndex = pt;
  pos[ptIndex].x = x;
  pos[ptIndex].y = y;
  pos[ptIndex].z = z;

  mass = m;
  mass_r = 1.0f/m;
}

#define fx1 2.0f/3.0f
#define fx2 1.0f/6.0f

void Point::calcPosition() 
{
  pos[ptIndex].x = pos[ptIndex].x + STEP_SIZE*velocity.x + 
    STEP_SIZE*STEP_SIZE * (fx1*a.x - fx2*aold.x);
  pos[ptIndex].y = pos[ptIndex].y + STEP_SIZE*velocity.y + 
    STEP_SIZE*STEP_SIZE * (fx1*a.y - fx2*aold.y);
  pos[ptIndex].z = pos[ptIndex].z + STEP_SIZE*velocity.z + 
    STEP_SIZE*STEP_SIZE * (fx1*a.z - fx2*aold.z);
  
  // init forces for next step
  force.y += mass * G; 
}

#define fv1 5.0f/12.0f
#define fv2 2.0f/3.0f
#define fv3 1.0f/12.0f

void Point::calcVelocity() {
  force.x *= mass_r;
  force.y *= mass_r; 
  force.z *= mass_r;
  
  velocity.x = velocity.x + STEP_SIZE * 
    (fv1*force.x + fv2*a.x - fv3*aold.x);
  velocity.y = velocity.y + STEP_SIZE * 
    (fv1*force.y + fv2*a.y - fv3*aold.y);
  velocity.z = velocity.z + STEP_SIZE * 
    (fv1*force.z + fv2*a.z - fv3*aold.z);

  aold.x = a.x; aold.y = a.y; aold.z = a.z; 
  a.x = force.x; a.y = force.y; a.z = force.z;

  force.x = 0.0f; force.y = 0.0f; force.z = 0.0f;
}

