#ifndef __PROCRUSTES_H
#define __PROCRUSTES_H

#include "gllib.h"

#define MAX_PROCRUSTES_N 16 // max number of points that can be fitted

class Procrustes
{
public:
  static void  FitObject(GLLIB_matrix &fitmatrix, GLLIB_vtx *to_vtx, GLLIB_vtx *from_vtx, int n);

private:
  static float Matrix_Det(float *a, int m, int n);
  static void  Matrix_Mul(float *dest, float *a, float *b, int ma, int na, int nb);
  static void  Matrix_Transpose(float *to, float *from, int m, int n);
};

#endif