#include "stdafx.h"
#include "rightangle.h"
#include "math3d.h"
#include <math.h>

void rightAngle::init(GLLIB_vtx *ps, Point *pt, int a, int b, int c) {
  pos = ps;
  pts = pt;
  p1 = a; 
  p2 = b;
  p3 = c;
}

#define TOL 0.0001f
#define MAX_FORCE 2000.0f

void rightAngle::applyForces() {
  
  GLLIB_vtx a = SubVector(pos[p1], pos[p2]);
  GLLIB_vtx b = SubVector(pos[p3], pos[p2]);

  float cos = a.x*b.x + a.y*b.y + a.z*b.z;
    
  if((cos > TOL) || (cos < TOL)) {
    
    float las = 1.0f/(a.x * a.x + a.y * a.y + a.z * a.z);
    float lbs = 1.0f/(b.x * b.x + b.y * b.y + b.z * b.z);

    float amp = -cos * MAX_FORCE * (float)sqrt(las * lbs);
    
    las *= cos;
    lbs *= cos;

    GLLIB_vtx f1;
    GLLIB_vtx f2;
    
    f1.x = a.x * las;
    f1.y = a.y * las;
    f1.z = a.z * las;

    f2.x = b.x * lbs;
    f2.y = b.y * lbs;
    f2.z = b.z * lbs;

    f1.x = (b.x - f1.x) * amp;
    f1.y = (b.y - f1.y) * amp;
    f1.z = (b.z - f1.z) * amp;

    f2.x = (a.x - f2.x) * amp;
    f2.y = (a.y - f2.y) * amp;
    f2.z = (a.z - f2.z) * amp;

    // cout << (f2.x * b.x + f2.y * b.y + f2.z * b.z) << " " << (f2.x * f2.x + f2.y * f2.y + f2.z * f2.z)  << endl;

    // apply forces
    pts[p1].force.x += f1.x;
    pts[p1].force.y += f1.y;
    pts[p1].force.z += f1.z;

    pts[p2].force.x += - f1.x - f2.x;
    pts[p2].force.y += - f1.y - f2.y;
    pts[p2].force.z += - f1.z - f2.z;
    
    pts[p3].force.x += f2.x;
    pts[p3].force.y += f2.y;
    pts[p3].force.z += f2.z;
  }
}
