#include "stdafx.h"

#include "spring.h"
#include <math.h>

void Spring::init(GLLIB_vtx *po, void *p, int i1, int i2, float ks, float ds) 
{
  pos = po;
  pt = p;
  p1 = i1;
  p2 = i2;

  float x = pos[p2].x - pos[p1].x;
  float y = pos[p2].y - pos[p1].y; 
  float z = pos[p2].z - pos[p1].z;

  initiallength = (float)sqrt( x*x + y*y + z*z );

  oldlength = initiallength;

  k = ks;
  d = ds;
}

void Spring::calcForce() 
{
  float force;
  
  float x = pos[p2].x - pos[p1].x;
  float y = pos[p2].y - pos[p1].y; 
  float z = pos[p2].z - pos[p1].z;

  float l = (float)sqrt( x*x + y*y + z*z );
 
  if(l < (STOP*initiallength))
  {
    force = (l - initiallength) * k * ENFORCE - (STOP*initiallength - initiallength)*k; 
  }
  else
  if(l > (2*initiallength - STOP*initiallength))
  {
    force = (l - initiallength) * k * ENFORCE + (STOP*initiallength - initiallength)*k;     
  }
  else 
    force = (l - initiallength) * k;
  
  float damp = -d*(oldlength - l) * STEP_SIZE_R; 
  
  oldlength = l;
  force = force+damp;
   
  if(l < INTERVAL) force = 0.0f;
  else force = force/l;

  x = x * force;
  y = y * force;
  z = z * force;
    
  Point *pts = (Point*) pt;
  
  pts[p1].force.x = pts[p1].force.x + x;
  pts[p1].force.y = pts[p1].force.y + y;
  pts[p1].force.z = pts[p1].force.z + z;

  pts[p2].force.x = pts[p2].force.x - x;
  pts[p2].force.y = pts[p2].force.y - y;
  pts[p2].force.z = pts[p2].force.z - z; 
}