#ifndef __SPRING_SIM_H_
#define __SPRING_SIM_H_

#include "simdef.h"
#include "point.h"
#include "collisiondedector.h"
#include "spring.h"
#include "poweredwheel.h"
#include "rightangle.h"
#include "steeringangle.h"
#include "damper.h"

class SpringSim 
{
public:
  SpringSim(); 
  ~SpringSim();

  GLLIB_vtx* getPointAddress();
  int getNumOfPts();

  Spring* getSpringAddress();
  int getNumOfSprings();

  PoweredWheel* getWheelAddress();
  int getNumOfWheels();

  steeringAngle* getSteeringAngleAddress();
  int getNumOfSteeringAngles();

  float step(int msecs);
  bool init(char *fname);

  CollisionDedector cd;
  
private:
  int numOfSprings;
  int numOfPoints;
  int numOfWheels;
  int numOfRAngles;
  int numOfSAngles;
  int numOfDampers;
  
  GLLIB_vtx *pos;
  Point *pts;
  Spring *sps;
  Damper *dmp;
  PoweredWheel *whl;
  rightAngle *ra;
  steeringAngle *sa;
};

#endif


