#include "stdafx.h"
#include "steeringangle.h"
#include "math3d.h"
#include <math.h>

void steeringAngle::init(GLLIB_vtx *ps, Point *pt, int a, int b, int c) {
  pos = ps;
  pts = pt;
  p1 = a;
  p2 = b;
  p3 = c;
  angle = 0.0f;
}

#define MAX_FORCE 2000.0f

void steeringAngle::applyForces() {
  GLLIB_vtx st = SubVector(pos[p2], pos[p3]);
  GLLIB_vtx ax = SubVector(pos[p2], pos[p1]);
  
  float lr_st = 1.0f/(float)sqrt(st.x*st.x + st.y*st.y + st.z*st.z);
  float lr_ax = 1.0f/(float)sqrt(ax.x*ax.x + ax.y*ax.y + ax.z*ax.z);
  
  float cos = st.x * ax.x + st.y * ax.y + st.z * ax.z;

  cos *= lr_st * lr_ax;  
  cos = - cos - angle; 

  st.x *= MAX_FORCE * cos;
  st.y *= MAX_FORCE * cos;
  st.z *= MAX_FORCE * cos;
  
  pts[p1].force.x -= st.x;
  pts[p1].force.y -= st.y;
  pts[p1].force.z -= st.z; 

  pts[p2].force.x += st.x;
  pts[p2].force.y += st.y;
  pts[p2].force.z += st.z;
}

void steeringAngle::setAngle(float a) {
  angle = a;
}
